searchNodes=[{"doc":"This can be used to generate factories for usage with ecto --repo is required Example $ mix factory_ex.gen --repo MyApp.Repo MyApp.Accounts.User $ mix factory_ex.gen --repo MyApp.Repo MyApp.Accounts.User MyApp.Accounts.Role Options dirname - Set directory name to generate into ../my_app/test/support/factory/ force - Force create files, no confirmations quiet - No output messages","ref":"Mix.Tasks.FactoryEx.Gen.html","title":"Mix.Tasks.FactoryEx.Gen","type":"task"},{"doc":"","ref":"Mix.Tasks.FactoryEx.Gen.html#ensure_schema_counter_start_added/1","title":"Mix.Tasks.FactoryEx.Gen.ensure_schema_counter_start_added/1","type":"function"},{"doc":"","ref":"Mix.Tasks.FactoryEx.Gen.html#generate_factory/3","title":"Mix.Tasks.FactoryEx.Gen.generate_factory/3","type":"function"},{"doc":"","ref":"Mix.Tasks.FactoryEx.Gen.html#matching_faker_functions/1","title":"Mix.Tasks.FactoryEx.Gen.matching_faker_functions/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.FactoryEx.Gen.html#run/1","title":"Mix.Tasks.FactoryEx.Gen.run/1","type":"function"},{"doc":"FactoryEx Installation Available in Hex , the package can be installed by adding factory_ex to your list of dependencies in mix.exs : def deps do [ { :factory_ex , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be found at https://hexdocs.pm/factory_ex . Using For defining your own factories just implement schema/0 , repo/0 and build/0 callback e.g: defmodule MyFactory do @behaviour FactoryEx def schema , do : MySchema def repo , do : MyRepo def build ( params \\\\ %{ } ) do default = %{ foo : 21 , bar : 42 } Map . merge ( default , params ) end end And then using it in your tests as: # For getting a default parameter map. FactoryEx . build ( MyFactory ) # For getting a default parameter map with a modification. FactoryEx . build ( MyFactory , foo : 42 ) # For getting a default parameter map and not validating the changeset FactoryEx . build ( MyFactory , [ foo : 42 ] , validate? : false ) # For inserting a default schema. FactoryEx . insert! ( MyFactory ) # For inserting a default schema with a modification. FactoryEx . insert! ( MyFactory , foo : 42 ) Using FactoryEx.SchemaCounter In order to avoid duplicate data on fields and guarentee unique data, we can use FactoryEx.SchemaCounter to generate unique integers to append to our fields. For example our factory could look like the following: defmodule MyFactory do @behaviour FactoryEx def schema , do : MySchema def repo , do : MyRepo def build ( params \\\\ %{ } ) do default = %{ foo : FactoryEx.SchemaCounter . next ( &quot;my_factory_foo&quot; ) , bar : FactoryEx.SchemaCounter . next ( &quot;my_factory_bar&quot; ) } Map . merge ( default , params ) end end To utilize FactoryEx.SchemaCounter , we must call FactoryEx.SchemaCounter.start() in the test/test_helper.exs file. Generating Factories FactoryEx comes with a helpful mix command to generate factories into our application $ mix factory_ex.gen --repo FactoryEx.Support.Repo FactoryEx.Support.Accounts.User $ mix factory_ex.gen --repo FactoryEx.Support.Repo FactoryEx.Support.{Accounts.{User,Role},Authentication.{Token,Session}} To read more info run mix factory_ex.gen FactoryEx.build options We can also specify options to &amp;FactoryEx.build/3 :keys - Sets the type of keys to have in the built object, can be one of :atom , :string or :camel_string","ref":"FactoryEx.html","title":"FactoryEx","type":"behaviour"},{"doc":"Callback that returns a map with valid defaults for the schema.","ref":"FactoryEx.html#c:build/1","title":"FactoryEx.build/1","type":"callback"},{"doc":"Builds a schema given the factory module and an optional list/map of params .","ref":"FactoryEx.html#build/3","title":"FactoryEx.build/3","type":"function"},{"doc":"","ref":"FactoryEx.html#build_invalid_params/1","title":"FactoryEx.build_invalid_params/1","type":"function"},{"doc":"Builds many parameters for a schema changeset/2 function given the factory module and an optional list/map of params .","ref":"FactoryEx.html#build_many_params/4","title":"FactoryEx.build_many_params/4","type":"function"},{"doc":"Builds the parameters for a schema changeset/2 function given the factory module and an optional list/map of params .","ref":"FactoryEx.html#build_params/3","title":"FactoryEx.build_params/3","type":"function"},{"doc":"Callback that returns a struct with valid defaults for the schema.","ref":"FactoryEx.html#c:build_struct/1","title":"FactoryEx.build_struct/1","type":"callback"},{"doc":"Removes all the instances of a schema from the database given its factory module .","ref":"FactoryEx.html#cleanup/2","title":"FactoryEx.cleanup/2","type":"function"},{"doc":"Inserts a schema given the factory module and an optional list/map of params . Fails on error.","ref":"FactoryEx.html#insert!/3","title":"FactoryEx.insert!/3","type":"function"},{"doc":"Insert as many as count schemas given the factory module and an optional list/map of params .","ref":"FactoryEx.html#insert_many!/4","title":"FactoryEx.insert_many!/4","type":"function"},{"doc":"Callback that returns the schema's repo module.","ref":"FactoryEx.html#c:repo/0","title":"FactoryEx.repo/0","type":"callback"},{"doc":"Callback that returns the schema module.","ref":"FactoryEx.html#c:schema/0","title":"FactoryEx.schema/0","type":"callback"},{"doc":"","ref":"FactoryEx.html#t:build_opts/0","title":"FactoryEx.build_opts/0","type":"type"},{"doc":"This is a counter module that wraps :counters Setting Up We can use this in our application by calling FactoryEx.SchemaCounter.start() inside our test/test_helper.exs file. Using SchemaCounter We can then use this module to add unique integers to each field, each value will only be used once provided we continue to call FactoryEx.SchemaCounter.next FactoryEx.SchemaCounter . next ( &quot;my_schema_field&quot; )","ref":"FactoryEx.SchemaCounter.html","title":"FactoryEx.SchemaCounter","type":"module"},{"doc":"Gets the counter for a specific key Example iex&gt; key = Enum . random ( 1 .. 10_000_000 ) iex&gt; FactoryEx.SchemaCounter . increment ( key ) :ok iex&gt; FactoryEx.SchemaCounter . get ( key ) 1","ref":"FactoryEx.SchemaCounter.html#get/1","title":"FactoryEx.SchemaCounter.get/1","type":"function"},{"doc":"Increments the counter for a specific key Example iex&gt; key = Enum . random ( 1 .. 10_000_000 ) iex&gt; FactoryEx.SchemaCounter . increment ( key ) :ok iex&gt; FactoryEx.SchemaCounter . get ( key ) 1","ref":"FactoryEx.SchemaCounter.html#increment/1","title":"FactoryEx.SchemaCounter.increment/1","type":"function"},{"doc":"Increments and gets the current value for a specific key Example iex&gt; key = Enum . random ( 1 .. 10_000_000 ) iex&gt; FactoryEx.SchemaCounter . next ( key ) 0 iex&gt; FactoryEx.SchemaCounter . next ( key ) 1 iex&gt; FactoryEx.SchemaCounter . next ( key ) 2","ref":"FactoryEx.SchemaCounter.html#next/1","title":"FactoryEx.SchemaCounter.next/1","type":"function"},{"doc":"Puts the counter for a specific key Example iex&gt; key = Enum . random ( 1 .. 10_000_000 ) iex&gt; FactoryEx.SchemaCounter . increment ( key ) :ok iex&gt; FactoryEx.SchemaCounter . put ( key , 1234 ) :ok iex&gt; FactoryEx.SchemaCounter . get ( key ) 1234","ref":"FactoryEx.SchemaCounter.html#put/2","title":"FactoryEx.SchemaCounter.put/2","type":"function"},{"doc":"This starts the SchemaCounter, you need to call this before calling any of the other functions in this module. Most commonly this will go in your test/test_helper.exs file","ref":"FactoryEx.SchemaCounter.html#start/0","title":"FactoryEx.SchemaCounter.start/0","type":"function"}]